Subject: Re: [patch net-next RFC 10/12] openvswitch: add support for datapath hardware offload

From: Jamal Hadi Salim <[email-masked]>
Date: Tue, 26 Aug 2014 10:00:58 -0400

On 08/25/14 18:11, Thomas Graf wrote:
> First of all, thanks for the animated discussion, wouldn't
> want to miss our arguments ;-)
>

Passion is key my friend;-> It is said that ancient Greeks
would ask of a person whose funeral they are thinking to attend
"was s/he passionate in life?" And if the answer is negative
they simply dont show up;->

> On 08/25/14 at 12:48pm, Jamal Hadi Salim wrote:
>> On 08/25/14 10:54, Thomas Graf wrote:

> I would argue that swflow is a superset of a Netlink route. It
> may infact be very useful to extend the API with something that
> understands the Netlink representation of a route and have the
> API translate that to a classifier that can be offloaded.
>

Sorry Thomas, I disagree.
A route has a lot more knobs than just a simple flow representation.
We are talking next hops (of which there could be multiple) etc.
There is no way you can boil that down to a simple flow representation.

>> I would be tagging along with you guys for flows if you:
>> a) allow for different classifiers. This allows me to implement
>> u32 and offload it.
>
> Agreed. What you seem to disagree on is:
>
>   - ndo_add_type1([...])
>   - ndo_add_type2([...])
>   - ndo_add_type3([...])
>
> vs.
>
>   - ndo_add_classifier(type, [...])
>

Only for what you call a "flow" - mostly because you have decided
on the universal classifier (lets call it THEONE).
Implementation-wise, you dont have to pass a type. It could be
a sub-ops() function pointer.

cheers,
jamal